Ruby - Bug #17486

Build fails on darwin due to libtool being removed
12/28/2020 07:15 PM - dark.panda (J Smith)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 3.0.0p0 (2020-12-25 revision Backport: 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7:
ccb58c9f76) [x86_64-darwin18] UNKNOWN

Description

The following commit is causing builds in master and for the recently released Ruby 3.0.0 to fail on darwin. This was tested on
macOS Mojave using the most recent XCode and Mojave patches. The error reported is as follows:

compiling bigdecimal.c

In file included from bigdecimal.c:13:

./bigdecimal.h:122:1: error: redefinition of 'rb_array_const_ptr'

rb_array_const_ptr (VALUE a)

../.././include/ruby/internal/core/rarray.h:184:1: note: previous definition is here
rb_array_const_ptr (VALUE a)

In file included from bigdecimal.c:13:

./bigdecimal.h:139:1: error: static declaration of 'rb_sym2str' follows non-static declaration
rb_sym2str (VALUE sym)

../.././include/ruby/internal/symbol.h:63:7: note: previous declaration is here

VALUE rb_sym2str (VALUE) ;

bigdecimal.c:109:1: error: static declaration of 'rb_rational_num' follows non-static declaration
rb_rational_num (VALUE rat)

../.././include/ruby/internal/intern/rational.h:39:7: note: previous declaration is here

VALUE rb_rational_num(VALUE rat);

bigdecimal.c:121:1: error: static declaration of 'rb_rational_den' follows non-static declaration
rb_rational_den (VALUE rat)

../.././include/ruby/internal/intern/rational.h:40:7: note: previous declaration is here

VALUE rb_rational_den (VALUE rat);

bigdecimal.c:133:1: error: static declaration of 'rb_complex_real' follows non-static declaration
rb_complex_real (VALUE cmp)

../.././include/ruby/internal/intern/complex.h:38:7: note: previous declaration is here

VALUE rb_complex_real (VALUE z);

bigdecimal.c:145:1: error: static declaration of 'rb_complex_imag' follows non-static declaration
rb_complex_imag (VALUE cmp)

../.././include/ruby/internal/intern/complex.h:39:7: note: previous declaration is here

VALUE rb_complex_imag (VALUE z);

6 errors generated.

make[2]: *** [bigdecimal.o] Error 1

make[l]: *** [ext/bigdecimal/all] Error 2

make: *** [build-ext] Error 2

Reverting the following commit allows the build to run successfully:

https://github.com/ruby/ruby/commit/ed01cc8fdc845b1db258eb3e35b3ba834463672e
https://github.com/ruby/ruby/commit/ed01cc8fdc845b1db258eb3e35b3ba834463672e

After reverting this commit on either master or the v3_0_0 tag, | was able to successfully build again.

History

#1 - 12/29/2020 03:50 AM - nobu (Nobuyoshi Nakada)

I've heard that similar error used to occur in earlier versions too,
and sudo xcode-select -s /Library/Developer/CommandLineTools may fix it.

#2 - 12/29/2020 03:54 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Feedback

#3 - 12/30/2020 11:46 PM - hsbt (Hiroshi SHIBATA)
FYI: https://github.com/rbenv/ruby-build/issues/1505#issuecomment-752274233

#4 - 12/30/2020 11:46 PM - dark.panda (J Smith)

| tried the following on a Macbook Pro with Catalina and the error was still present.

$ sudo rm -rf /Library/Developer/CommandLineTools
$ xcode-select --install
$ sudo xcode-select -s /Library/Developer/CommandLineTools

#5 - 02/03/2021 05:03 AM - pbernays (Paul Bernays)

Adding a data point to this. I've also tried reinstalling the CLTs on Catalina, but the build only succeeded with the reverted commit. Big Sur doesn't
support my iMac, so I'm stuck with Catalina for good.

#6 - 02/07/2021 11:41 PM - charlesbjohnson (Charles Johnson)

I'm running into this exact same issue, it fails on both Catalina and Big Sur.

$ ASDF_RUBY_BUILD_VERSION=master RUBY_CONFIGURE_OPTS="--with-openssl-dir=$ (brew --prefix openssl) --with-readl
ine-dir=$ (brew --prefix readline)" asdf install ruby 3.0.0

Downloading ruby-build...

Cloning into '/Users/cbjohnson/.asdf/plugins/ruby/ruby-build-source’...
remote: Enumerating objects: 18, done.

remote: Counting objects: 100% (18/18), done.

remote: Compressing objects: 100% (13/13), done.

remote: Total 11325 (delta 4), reused 11 (delta 3), pack-reused 11307
Receiving objects: 100% (11325/11325), 2.41 MiB | 7.18 MiB/s, done.
Resolving deltas: 100% (7471/7471), done.

Already on 'master'

Downloading ruby-3.0.0.tar.gz...

-> https://cache.ruby-lang.org/pub/ruby/3.0/ruby-3.0.0.tar.gz
Installing ruby-3.0.0...

BUILD FAILED (macOS 11.2 using ruby-build 20210119)

Inspect or clean up the working tree at /var/folders/4y/tl_w3pfl2k31z9tmf4dhh79tr0000gn/T/ruby-build.2021020717
2219.84379.0JCgoQ
Results logged to /var/folders/4y/tl_w3pfl2k31z9tmf4hh79tr0000gn/T/ruby-build.20210207172219.84379.1og

Last 10 log lines:

linking shared-object digest.bundle

linking shared-object etc.bundle

linking shared-object dbm.bundle

make[2]: Leaving directory ' /private/var/folders/4y/tl_w3pfl2k31z9tmf4hh79tr0000gn/T/ruby-build.20210207172219
.84379.0JCgoQ/ruby—-3.0.0/ext/digest"'

make[2]: Leaving directory ' /private/var/folders/4y/tl_w3pf12k31z9tmf4hh79tr0000gn/T/ruby-build.20210207172219
.84379.QJCgoQ/ruby—-3.0.0/ext/etc"

make[2]: Leaving directory °/private/var/folders/4y/tl_w3pfl2k31z9tmf4hh79tr0000gn/T/ruby-build.20210207172219
.84379.0JCgoQ/ruby—-3.0.0/ext/dbm’

linking shared-object date_core.bundle

make[2]: Leaving directory °/private/var/folders/4y/tl_w3pfl2k31z9tmf4hh79tr0000gn/T/ruby-build.20210207172219
.84379.QJCgoQ/ruby-3.0.0/ext/date"

gmake[l]: Leaving directory '/private/var/folders/4y/tl_w3pfl2k31z9tmf4hh79tr0000gn/T/ruby-build.2021020717221
9.84379.Q0JCgoQ/ruby-3.0.0"

gmake: *** [uncommon.mk:300: build-ext] Error 2

$ xcodebuild -version
Xcode 12.4
https://github.com/rbenv/ruby-build/issues/1505#issuecomment-752274233

Build version 12D4e

$ sw_vers

ProductName: macOS
ProductVersion: 11.2
BuildVersion: 20D64

Complete build log: https://gist.qgithub.com/charlesbjohnson/bc384e90b985d02854380fb476fd22b0

#7 - 02/08/2021 05:21 AM - nobu (Nobuyoshi Nakada)

Could you show mkmf.log file for a failed extension?

#8 - 02/24/2021 06:40 AM - charlesbjohnson (Charles Johnson)

nobu (Nobuyoshi Nakada) wrote in #note-7:

Could you show mkmf.log file for a failed extension?

Here's what | have for ext/bigdecimal/mkmf.log: https:/gist.github.com/charlesbjohnson/1b280cd5fe041824de68dd04bc6fafed

#9 - 02/24/2021 06:37 PM - charlesbjohnson (Charles Johnson)

charlesbjohnson (Charles Johnson) wrote in #note-8:

nobu (Nobuyoshi Nakada) wrote in #note-7:

Could you show mkmf.log file for a failed extension?

Here's what | have for ext/bigdecimal/mkmf.log: hitps:/gist.github.com/charlesbjohnson/1b280cd5fe041824de68dd04bc6fafe

Good news is that | was able to build 3.0.0. The culprit appeared to be that I'm using the GNU coreutils and related packages (ie. gmake instead of
make) installed from Homebrew instead of the usual binaries that come included with macOS. When | unlinked them and used the macOS binaries |
was able to build without issue.

For what it's worth, though, I've never ran into this issue with previous Ruby releases.

#10 - 03/12/2021 01:10 PM - nobu (Nobuyoshi Nakada)
- Status changed from Feedback to Closed

#11 - 07/20/2021 04:55 PM - dark.panda (J Smith)
This is still failing for me on Big Sur with 3.0.2. | have made sure to uninstall gmake and coreutils from MacPorts but it is still failing. If | revert commit |

mentioned in the original report then it builds fine on Big Sur under all conditions, with or without GNU coreutils.

#12 - 07/20/2021 10:37 PM - nobu (Nobuyoshi Nakada)

Id: warning: ignoring file ../../libruby.3.0-static.a, building for macOS-x86_64 but attempting to link with file built for macOS-x86_64

This message appears to be contradictory.
Isn’t ranlib working?
